# Copyright (c) 2013, Fafadia Tech and contributors
# For license information, please see license.txt

"""
GTL Engineer wise customer RFQ Status Report

Report Logic and Description is available on following youtube link

https://www.youtube.com/watch?v=IpuS0d_zcgo&feature=youtu.be
"""

from __future__ import unicode_literals
import frappe
from frappe import _


def execute(filters=None):
    """
    GTL Engineer wise customer RFQ Status Report

    Report Logic and Description is available on following youtube link

    https://www.youtube.com/watch?v=IpuS0d_zcgo&feature=youtu.be
    """
    data = []
    columns = [{"fieldname": "customer_rfq_no", "label": _("Customer RFQ No"), "fieldtype": "Data"},
               {"fieldname": "complete_by", "label": _("Complete By"), "fieldtype": "Data"},
               {"fieldname": "c_rfq_status", "label": _("C.RFQ Status"), "fieldtype": "Data"},
               {"fieldname": "status_remarks", "label": _("Status Remarks"), "fieldtype": "Data"}
               ]
    # get user full_name from fiters if name not available return blank data
    full_name = filters.get("user")
    frappe.logger().debug(full_name)
    frappe.logger().debug(filters)
    if full_name:
        # get user object from users full name
        user = frappe.get_value("User", filters={"full_name": full_name})
        assigned_to = '["{}"]'.format(user)
        # get list of opportunities assigned to user
        opportunities = frappe.get_list("Opportunity", filters={
            "_assign": assigned_to}, fields=["name", "rfq_no",
            "gtl_complete_by_date", "gtl_quote_status",
            "gtl_status_remark"])
        for o in opportunities:
            frappe.logger().debug(o)
            data_dict = {}
            data_dict["customer_rfq_no"] = o.rfq_no
            data_dict["complete_by"] = o.gtl_complete_by_date
            data_dict["c_rfq_status"] = o.gtl_quote_status
            data_dict["status_remarks"] = o.gtl_status_remark
            data.append(data_dict)
    return columns, data
